package de.ba_leipzig.discoinv;

import java.awt.Component;
import java.sql.SQLException;

import javax.swing.JOptionPane;

import de.ba_leipzig.discoinv.db.DBIntegrityException;
import de.ba_leipzig.discoinv.db.DBManagerLoadException;

public class ExceptionHandler {
	private Component parent;
	
	public ExceptionHandler(Component parent){
		this.parent = parent;
	}
	
	
	public void handle(DBManagerLoadException e){
		JOptionPane.showMessageDialog(parent, new String[]{
			"Es ist ein schwerwiegendes Datenbankproblem aufgetreten:",
			"Der Datenbankmanager konnte nicht geladen werden.",
			"Bitte berprfen Sie die Konfigurationsdatei!",
			"",
			"Das Programm wird beendet.",
			" ",
			"--- Fehlernachricht ---",
			e.getMessage()},
			"DiscoInv", JOptionPane.WARNING_MESSAGE);
		System.exit(-1);
	}
	
	public void handle(SQLException e, String msg){
		JOptionPane.showMessageDialog(parent, new String[]{msg, e.getMessage()},
			"Datenbankfehler", JOptionPane.WARNING_MESSAGE);
	}
	
	public void handle(DBIntegrityException e, String msg){
		JOptionPane.showMessageDialog(parent, new String[]{msg, e.getMessage()},
			"Datenbankintegrittsfehler", JOptionPane.WARNING_MESSAGE);
	}
	
	public void handle(Exception e, String title, String... msg){
		JOptionPane.showMessageDialog(parent, msg, title,
			JOptionPane.WARNING_MESSAGE);
	}
}