package de.ba_leipzig.discoinv.db;

import java.io.Serializable;

public class BeverageType implements Serializable {
	private static final long serialVersionUID = 3460185682917044856L;
	private int id;
	private String name;
	
	public BeverageType(){
		// Standardkonstruktor
	}
	
	public BeverageType(int id, String name){
		if(id < 0 || name.equals("")){
			throw new IllegalArgumentException();
		}
		
		this.id = id;
		this.name = name;
	}
	
	public boolean equals(Object object){
		if(object != null && object.getClass() == this.getClass()){
			BeverageType type = (BeverageType)object;
			return this.id == type.id && this.name.equals(type.name);
		}
		return false;
	}
	
	public int hashCode(){
		return name.hashCode() + 7 * id;
	}
	
	public int getId() {
		return id;
	}
	
	public String getName() {
		return name;
	}
	
	public void setId(int id) {
		if(id < 0){
			throw new IllegalArgumentException();
		}
		
		this.id = id;
	}
	
	public void setName(String name) {
		if(name.equals("")){
			throw new IllegalArgumentException();
		}
		
		this.name = name;
	}
	
	public String toString(){
		return getName();
	}
}