package de.ba_leipzig.discoinv.db;

public class BeverageWithLevel extends Beverage {
	private static final long serialVersionUID = 6788259641840573443L;
	
	private int current;
	private int empty;
	private int full;
	
	/**
	 * Ein offenes Getrnk erzeugen
	 */
	public BeverageWithLevel(){
		// Standardkonstruktor
	}
	
	/**
	 * Ein offenes Getrnk erzeugen
	 * @param id
	 * @param name
	 * @param alc
	 * @param refund
	 * @param capacity
	 * @param type
	 * @param empty
	 * @param full
	 * @param current
	 */
	public BeverageWithLevel(int id, String name, boolean alc, boolean refund,
							int capacity, BeverageType type, int empty, int full, int current) {
		super(id, name, alc, refund, capacity, type);
		this.empty=empty;
		this.full=full;
		this.current=current;
	}

	/**
	 * Ein offenes Getrnk erstellen. Es wird angenommen, dass es voll ist.
	 * @param id
	 * @param name
	 * @param alc
	 * @param refund
	 * @param capacity
	 * @param type
	 * @param empty
	 * @param full
	 */
	public BeverageWithLevel(int id, String name, boolean alc, boolean refund,
							int capacity, BeverageType type, int empty, int full) {
		super(id, name, alc, refund, capacity, type);
		this.empty=empty;
		this.full=full;
		this.current=full;
	}
	
	public int getCurrent() {
		return current;
	}
	
	public int getEmpty() {
		return empty;
	}
	
	public int getFull() {
		return full;
	}
	
	public void setCurrent(int current) {
		this.current = current;
	}
	
	public void setEmpty(int empty) {
		this.empty = empty;
	}
	
	public void setFull(int full) {
		this.full = full;
	}
}