package de.ba_leipzig.discoinv.db;

import de.ba_leipzig.discoinv.Config;

public abstract class DBManagerFactory {
	private static DatabaseManager dbManager;
	private static Config config = new Config();
	
	public static DatabaseManager getDatabaseManager() throws DBManagerLoadException {
		if(dbManager == null){
			try {
				String className = config.getDBManager();
				dbManager = (DatabaseManager)Class.forName(className).newInstance();
			}
			catch(Throwable t){
				throw new DBManagerLoadException(t);
			}
		}
		
		return dbManager;
	}
}