package de.ba_leipzig.discoinv.db;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;

public class DBWrapper {
	// Variable fr die Verbindung zur DB
    private Connection conn = null;
    
    /**
     * Ladet den JDBC Treiber fr SQLite und stellt eine Verbindung zur angegeben Datenbank her
     * @return true bei Erfolg, sonst false
     */
    public boolean init(String pfad){
    	// SQLite JDBC treiber laden
		try {
			Class.forName("org.sqlite.JDBC");
		}
		catch (ClassNotFoundException e){
			System.err.println( "Keine Treiber-Klasse fr die JDBC verbindung gefunden!" ); 
			e.printStackTrace();
			return false;
		}
		
		System.out.println("JDBC geladen.");
		
		// zur DB verbinden
		try {
			conn = DriverManager.getConnection("jdbc:sqlite:"+pfad);
		}
		catch (SQLException e){
			System.err.println( "Konnte nicht zur Datenbank verbinden!" );
			e.printStackTrace();
			return false;
		}
		
		System.out.println("Verbindung zur DB hergestellt.");
		
		// TODO prfen ob die DB leer ist
		
		return true;
    }
    
    /**
     * Beendet die Verbindnung zur Datenbank
     */
    public void exit(){
    	if ( conn != null ) 
    		try { conn.close(); } catch ( SQLException e ) { e.printStackTrace(); } 
    }
}