package de.ba_leipzig.discoinv.db;

import java.io.Serializable;

public class Place implements Identifiable, Nameable, Serializable {
	private static final long serialVersionUID = 5438658340248125353L;
	
	private Integer id;
	private Integer depotID;
	private String name;
	
	/**
	 * einen Standort erstellen
	 */
	public Place(){
		// Standardkonstruktor
	}
	
	/**
	 * einen Standort erstellen
	 * @param id
	 * @param name
	 * @param depotID ID des Depo-Standortes
	 */
	public Place(Integer id, String name, Integer depotID){
		this.id=id;
		this.depotID=depotID;
		this.name=name;
	}

	/**
	 * einen Standort erstellen
	 * @param id
	 * @param name
	 */
	public Place(int id, String name){
		this.id=id;
		this.name=name;
	}
	
	public boolean equals(Object object){
		if(object != null && object instanceof Place){
			Place place = (Place)object;
			return place.id == this.id;
		}
		return false;
	}
	
	public int hashCode(){
		return 31 * id;
	}
	
	public Integer getDepotID() {
		return depotID;
	}
	
	public int getID() {
		return ((id==null)?(0):(id));
	}
	
	public String getName() {
		return name;
	}
	
	public boolean isDepot() {
		return depotID == null;
	}
	
	public void setDepotID(int depotID) {
		this.depotID = depotID;
	}
	
	public void setID(Integer id){
		this.id = id;
	}
	
	public void setName(String name) {
		this.name = name;
	}
	
	public String toString(){
		return getName();
	}
}