package de.ba_leipzig.discoinv.dialogs;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;

public abstract class AbstractAddDialog extends AbstractDialog {
	protected static final int TOTAL_WIDTH = 260;
	protected static final int NORMAL_HEIGHT = 20;
	protected static final int NORMAL_DISTANCE = 5;
	

	public AbstractAddDialog(JFrame owner) {
		super(owner, true);
		setResizable(false);
	}

	public AbstractAddDialog(JFrame owner, boolean init) {
		super(owner, init);
		setResizable(false);
	}

	protected String getOkButtonCaption() {
		return "Hinzufgen";
	}

	protected ActionListener getOkButtonHandler() {
		return new ActionListener(){
			public void actionPerformed(ActionEvent e){
				okAction();
			}
		};
	}
	
	protected void okAction(){
		Window parent = getOwner();
		Cursor cursor = parent.getCursor();
		parent.setCursor(new Cursor(Cursor.WAIT_CURSOR));
		
		try {
			doOkAction();
		}
		finally {
			dispose();
			parent.setCursor(cursor);
		}
	}
	
	protected void enableOkButton(){
		if(activateOkButton()){
			getJOkButton().setEnabled(true);
		}
		else {
			getJOkButton().setEnabled(false);
		}
	}
	
	protected abstract boolean activateOkButton();
	protected abstract void doOkAction();
}