package de.ba_leipzig.discoinv.dialogs;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.event.*;

import de.ba_leipzig.discoinv.db.*;

public abstract class AbstractAddObjectDialog extends AbstractAddDialog {
	private JPanel jEntryPanel;
	private JPanel jNamePanel;
	private JTextField jNameTextField;
	private Identifiable newObject;
	
	public AbstractAddObjectDialog(JFrame owner) {
		super(owner);
	}

	/**
	 * {@inheritDoc}
	 */
	protected JPanel getJEntryPanel() {
		if(jEntryPanel == null){
			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
			gridBagConstraints1.gridx = 0;
			gridBagConstraints1.gridy = 0;
			jEntryPanel = new JPanel();
			jEntryPanel.setLayout(new GridBagLayout());
			jEntryPanel.add(getJNamePanel(), gridBagConstraints1);
			addMore(jEntryPanel);
		}
		return jEntryPanel;
	}
	
	/**
	 * This method initializes jNamePanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJNamePanel() {
		if (jNamePanel == null) {
			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
			gridBagConstraints1.fill = GridBagConstraints.VERTICAL;
			gridBagConstraints1.weightx = 1.0;
			jNamePanel = new JPanel();
			jNamePanel.setLayout(new GridBagLayout());
			jNamePanel.setBorder(BorderFactory.createTitledBorder("Bezeichnung"));
			jNamePanel.add(getJNameTextField(), gridBagConstraints1);
		}
		return jNamePanel;
	}

	/**
	 * This method initializes jNameTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	protected JTextField getJNameTextField() {
		if (jNameTextField == null) {
			jNameTextField = new JTextField();
			Dimension size = new Dimension(TOTAL_WIDTH, NORMAL_HEIGHT);
			jNameTextField.setPreferredSize(size);
			jNameTextField.requestFocus();
			
			jNameTextField.addCaretListener(new CaretListener(){
				public void caretUpdate(CaretEvent e){
					enableOkButton();
				}
			});
			
			jNameTextField.addKeyListener(new KeyAdapter(){
				public void keyReleased(KeyEvent event){
					if(event.getKeyCode() == KeyEvent.VK_ENTER &&
							getJOkButton().isEnabled()){
						okAction();
					}
				}
			});
		}
		return jNameTextField;
	}
	
	protected void addMore(JPanel jEntryPanel){}
	
	protected boolean activateOkButton(){
		return true;
	}
	
	protected void enableOkButton(){
		if(!getJNameTextField().getText().equals("") &&
				activateOkButton()){
			getJOkButton().setEnabled(true);
		}
		else {
			getJOkButton().setEnabled(false);
		}
	}
	
	public String getObjectName(){
		return getJNameTextField().getText();
	}
	
	public Identifiable getObject(){
		return newObject;
	}
	
	protected void setObject(Identifiable newObject){
		this.newObject = newObject;
	}
}