package de.ba_leipzig.discoinv.dialogs;

import java.sql.SQLException;
import java.util.*;

import javax.swing.*;

import de.ba_leipzig.discoinv.db.*;
import de.matthiasrothe.util.collections.*;

public abstract class AbstractEditAssociationDialog extends
		AbstractAssociationDialog {

	public AbstractEditAssociationDialog(JFrame owner) {
		super(owner);
	}

	protected void initialize(){
		super.initialize();
		fillObjectsTable();
		
		if(getTableModel().getRowCount() > 0){
			getTableSelectionModel().setSelectionInterval(0, 0);
		}
		
		enableOkButton();
	}
	
	protected boolean activateObjectComboBox(){
		return false;
	}
	
	protected void finishAddAction(){
		getTableSelectionModel().setLeadSelectionIndex(0);
	}
	
	protected boolean activateOkButton() {
		if(state.isEditing()){
			return false;
		}
		else {
			return true;			
		}
	}
	
	protected boolean addRemovedItemToComboBox(){
		return false;
	}
	
	protected void doFillObjectComboBox() throws SQLException,
			DBManagerLoadException {
		getJObjectComboBox().setEnabled(false);
	}
	
	protected int getEntryPosition(String entry){
		OrderedIndexFinder<String> finder =
			new OrderedIndexFinder<String>(
					new DataAccessorStrategy<String>(){
						public String getElementAt(int index){
							return ((Nameable)((Vector)getTableModel()
									.getDataVector().get(index)).get(0))
									.getName();
						}

						public int getSize() {
							return getTableModel().getRowCount();
						}
					});
		
		return finder.getOrderedIndex(entry);
	}
	
	
	
	protected abstract void fillObjectsTable();
}