package de.ba_leipzig.discoinv.dialogs;

import java.sql.SQLException;
import java.util.*;

import javax.swing.*;

import de.ba_leipzig.discoinv.db.*;

public class AddBeverageAssociationDialog extends AbstractAssociationDialog {
	private static final long serialVersionUID = -4789048147208833528L;
	private DialogCaptions captions = new DialogCaptions();
	private Place place;
	
	public AddBeverageAssociationDialog(JFrame owner, Place place) {
		super(owner);
		
		if(place == null){
			throw new IllegalArgumentException("place must not be null!");
		}
		
		this.place = place;
		initialize();
	}
	
	protected void doFillObjectComboBox()
	throws DBManagerLoadException, SQLException {
		DatabaseManager dbManager = DBManagerFactory.getDatabaseManager();
		Set<Beverage> beverages = dbManager.getBeveragesNotAtPlace(place);
		if(beverages != null) for(Beverage beverage : beverages){
			getJObjectComboBox().addItem(beverage);
		}
	}
	
	protected String getChoosePanelCaption() {
		return captions.getBeverageChoosePanelCaption();
	}

	protected String getChosenPanelCaption() {
		return captions.getBeverageChosenPanelCaption();
	}

	protected String getDescription() {
		return "Neue Getrnke zu " + place.getName() + " hinzufgen";
	}

	protected String getObjectCaption() {
		return captions.getBeverageObjectCaption();
	}

	protected String getDialogTitle() {
		return "Neue Zuordnungen: Getrnke";
	}

	protected String getAddButtonCaption() {
		return captions.getAddButtonCaptionForAdd();
	}

	protected void doDBAction(DatabaseManager dbManager,
			Set<AssociationInfo<Identifiable>> associations)
	throws SQLException {
		dbManager.addObjectAssociations(place, associations);
	}
}