package de.ba_leipzig.discoinv.dialogs;

import java.sql.SQLException;
import java.util.Set;

import javax.swing.*;

import de.ba_leipzig.discoinv.db.*;

public class AddMiscAssociationDialog extends AbstractAssociationDialog {
	private static final long serialVersionUID = -3245259265429162179L;
	private DialogCaptions captions = new DialogCaptions();
	private Place place;
	
	public AddMiscAssociationDialog(JFrame owner, Place place) {
		super(owner);
		
		if(place == null){
			throw new IllegalArgumentException("place must not be null!");
		}
		
		this.place = place;
		initialize();
	}
	
	protected String getChoosePanelCaption() {
		return captions.getMiscChoosePanelCaption();
	}
	
	protected String getChosenPanelCaption() {
		return captions.getMiscChosenPanelCaption();
	}
	
	protected String getDescription() {
		return "Neue Sonstige zu " + place.getName() + " hinzufgen";
	}
	
	protected String getObjectCaption() {
		return captions.getMiscObjectCaption();
	}
	
	protected String getDialogTitle() {
		return "Neue Zuordnungen: Sonstige";
	}

	protected String getAddButtonCaption() {
		return captions.getAddButtonCaptionForAdd();
	}

	protected void doFillObjectComboBox()
	throws SQLException, DBManagerLoadException {
		DatabaseManager dbManager = DBManagerFactory.getDatabaseManager();
		Set<InvObject> miscs = dbManager.getMiscNotAtPlace(place);
		if(miscs != null) for(InvObject misc : miscs){
			getJObjectComboBox().addItem(misc);
		}
	}

	protected void doDBAction(DatabaseManager dbManager,
			Set<AssociationInfo<Identifiable>> associations)
	throws SQLException {
		dbManager.addObjectAssociations(place, associations);
	}
}