package de.ba_leipzig.discoinv.dialogs;

import javax.swing.*;

import de.ba_leipzig.discoinv.db.*;

import java.awt.*;
import java.sql.SQLException;

public class AddMiscDialog extends AbstractAddObjectDialog {
	private static final long serialVersionUID = 7963286248206389229L;
	
	public AddMiscDialog(JFrame owner) {
		super(owner);
	}

	protected Dimension getDialogSize() {
		return new Dimension(300, 200);
	}

	protected String getDialogTitle() {
		return "Sonstiges hinzufgen";
	}

	protected void doOkAction() {
		InvObject object = new InvObject();
		object.setName(getJNameTextField().getText());
		
		try {
			DBManagerFactory.getDatabaseManager().addInvObject(object);
			setObject(object);
			exitType = OK;
		}
		catch(DBManagerLoadException e){
			handle(e);
		}
		catch(SQLException e){
			handle(e, getDBExceptionMessage());
		}
		catch(DBIntegrityException e){
			handle(e, getDBExceptionMessage());
		}
	}
	
	private String getDBExceptionMessage(){
		return "Beim Hinzufgen eines Inventarobjekts";
	}
}