package de.ba_leipzig.discoinv.dialogs;

import java.sql.SQLException;
import java.util.Set;

import javax.swing.*;

import de.ba_leipzig.discoinv.db.*;

public class AddPlaceAssociationDialog extends AbstractAssociationDialog {
	private static final long serialVersionUID = -6544741156140378771L;
	private DialogCaptions captions = new DialogCaptions();
	private InvObject object;
	
	public AddPlaceAssociationDialog(JFrame owner, InvObject object) {
		super(owner);
		
		if(object == null){
			throw new IllegalArgumentException("object must not be null!");
		}
		
		this.object = object;
		initialize();
	}

	protected String getChoosePanelCaption() {
		return captions.getPlaceChoosePanelCaption();
	}

	protected String getChosenPanelCaption() {
		return captions.getPlaceChosenPanelCaption();
	}

	protected String getDescription() {
		return object.getName() + " zu neuen Standorten hinzufgen";
	}

	protected String getObjectCaption() {
		return captions.getPlaceObjectCaption();
	}

	protected String getDialogTitle() {
		return "Neue Zuordnungen: Standorte";
	}

	protected String getAddButtonCaption() {
		return captions.getAddButtonCaptionForAdd();
	}

	protected void doFillObjectComboBox()
	throws SQLException, DBManagerLoadException {
		DatabaseManager dbManager = DBManagerFactory.getDatabaseManager();
		Set<Place> places = dbManager.getPlacesObjectNotAt(object);
		if(places != null) for(Place place : places){
			getJObjectComboBox().addItem(place);
		}
	}

	protected void doDBAction(DatabaseManager dbManager,
			Set<AssociationInfo<Identifiable>> associations)
	throws SQLException {
		dbManager.addPlaceAssociations(object, associations);
	}
}