package de.ba_leipzig.discoinv.dialogs;

import java.sql.SQLException;

import javax.swing.JFrame;

import de.ba_leipzig.discoinv.db.*;

public class EditBeverageDialog extends AddBeverageDialog {
	private static final long serialVersionUID = 3360525829396300317L;
	private Beverage beverage;
	
	public EditBeverageDialog(JFrame owner, Beverage beverage){
		super(owner);
		
		if(beverage == null){
			throw new IllegalArgumentException("beverage must not be null!");
		}
		
		this.beverage = beverage;
		initDialog(false);
	}
	
	public EditBeverageDialog(JFrame owner, BeverageWithLevel beverage){
		super(owner);
		
		if(beverage == null){
			throw new IllegalArgumentException("beverage must not be null!");
		}
		
		this.beverage = beverage;
		initDialog(true);
	}
	
	private void initDialog(boolean isBeverageWithLevel){
		getJNameTextField().setText(beverage.getName());
		getJAlcCheckBox().setSelected(beverage.isAlc());
		getJRefundCheckBox().setSelected(beverage.isRefund());
		getJCapacityTextField().setText(
				((Integer)beverage.getCapacity()).toString());
		getJTypeComboBox().setSelectedItem(beverage.getType());
		
		if(isBeverageWithLevel){
			int empty = ((BeverageWithLevel)beverage).getEmpty();
			int full = ((BeverageWithLevel)beverage).getFull();
			
			getJLevelCheckBox().doClick();
			getJEmptyLevelTextField().setText(((Integer)empty).toString());
			getJFullLevelTextField().setText(((Integer)full).toString());
		}
		
		enableOkButton();
	}
	
	protected String getOkButtonCaption(){
		return "Daten ndern";
	}
	
	protected String getDialogTitle(){
		return "Getrnkedaten ndern";
	}

	protected void doDBAction(DatabaseManager dbManager, Beverage beverage)
	throws SQLException {
		beverage.setID(this.beverage.getID());
		dbManager.updateBeverage(beverage);
		setObject(beverage);
	}
	
	protected void doDBAction(DatabaseManager dbManager, BeverageWithLevel beverage)
	throws SQLException {
		beverage.setID(this.beverage.getID());
		dbManager.updateBeverage(beverage);
		setObject(beverage);
	}
	
	protected String getDBExceptionMessage(){
		return "Beim ndern der Daten eines Getrnks";
	}
}