package de.ba_leipzig.discoinv.dialogs;

import java.sql.SQLException;

import javax.swing.*;

import de.ba_leipzig.discoinv.db.*;

public class EditPlaceDialog extends AddPlaceDialog {
	private static final long serialVersionUID = 1850479646320593574L;
	private Place place;
	
	public EditPlaceDialog(JFrame owner, Place place){
		super(owner);
		
		if(place == null){
			throw new IllegalArgumentException("place must not be null!");
		}
		
		this.place = place;
		initDialog();
	}
	
	private void initDialog(){
		getJNameTextField().setText(place.getName());
		
		// Wenn Lager verwendet
		if(place.getDepotID() != null){
			Place depot = new Place();
			depot.setID(place.getDepotID());
			getJDepotCheckBox().setSelected(true);
			getJDepotComboBox().setSelectedItem(depot);
			getJDepotComboBox().setEnabled(true);
		}
		
		// Ok Button aktivieren
		enableOkButton();
	}
	
	protected String getOkButtonCaption(){
		return "Daten ndern";
	}
	
	protected String getDialogTitle(){
		return "Standortdaten ndern";
	}

	protected void doDBAction(DatabaseManager dbManager, Place place)
	throws SQLException {
		place.setID(this.place.getID());
		dbManager.updatePlace(place);
		setObject(place);
	}
	
	protected String getDBExceptionMessage(){
		return "Beim ndern der Daten eines Standorts";
	}
}