/**
 * 
 */
package de.ba_leipzig.discoinv.dialogs;

import javax.swing.*;

import de.matthiasrothe.util.collections.*;

class OrderedComboBoxModel extends DefaultComboBoxModel {
	private JComboBox jComboBox;

	/**
	 * @param dialog
	 */
	public OrderedComboBoxModel(JComboBox jComboBox) {
		if(jComboBox == null){
			throw new IllegalArgumentException("jComboBox must not be null!");
		}
		
		this.jComboBox = jComboBox;
	}

	private static final long serialVersionUID = 923726427226189519L;
	
	public void addElement(Object object){
		OrderedIndexFinder<String> finder =
			new OrderedIndexFinder<String>(
					new DataAccessorStrategy<String>(){
						public String getElementAt(int index){
							return jComboBox.getItemAt(index).toString();
						}
						
						public int getSize(){
							return jComboBox.getItemCount();
						}
					});
		
		int index = finder.getOrderedIndex(object.toString());
		insertElementAt(object, index);
	}
}