package de.ba_leipzig.discoinv.tables;

public class ColumnData {
	private String title;
	private String toolTip;
	protected Class<?> clazz;
	
	public ColumnData(String title, Class<?> clazz){
		if(title == null || clazz == null){
			throw new IllegalArgumentException("parameters must not be null!");
		}
		
		this.title = title;
		this.clazz = clazz;
	}
	
	public ColumnData(String title, String toolTip, Class<?> clazz){
		this(title, clazz);
		
		if(toolTip == null){
			throw new IllegalArgumentException("toolTip must not be null");
		}
		
		this.toolTip = toolTip;
	}
	
	/**
	 * @return the clazz
	 */
	public Class<?> getClazz(){
		return clazz;
	}
	
	/**
	 * @return the title
	 */
	public String getTitle(){
		return title;
	}
	
	/**
	 * @return the toolTip
	 */
	public String getToolTip(){
		return toolTip;
	}
	
	public String toString(){
		return getTitle();
	}
}