package de.ba_leipzig.discoinv.tables;

import java.util.*;

import javax.swing.table.*;

public class GenericTableModel extends DefaultTableModel {
	private static final long serialVersionUID = -7162479022579450232L;
	private Vector<ColumnData> columnData;
	
	public GenericTableModel(){
		this(new Vector(), new Vector<ColumnData>());
	}
	
	public GenericTableModel(Vector data, Vector<ColumnData> columnData){
		super(data, columnData);
		
		if(columnData == null){
			throw new IllegalArgumentException("columnData must not be null!");
		}
		
		this.columnData = new Vector<ColumnData>(columnData);
	}
	
	public boolean isCellEditable(int row, int column){
		return false;
	}
	
	public Class<?> getColumnClass(int column){
		return columnData.get(column).getClazz();
	}
	
	public String getColumnToolTip(int column){
		return columnData.get(column).getToolTip();
	}
	
	@SuppressWarnings("unchecked")
	public Vector<Vector<Object>> getDataVector(){
		return dataVector;
	}
}