package de.ba_leipzig.discoinv.tables;

import de.matthiasrothe.util.rating.RatingProcessor;

public class RatingColumnData extends ColumnData {
	private RatingProcessor processor;
	
	public RatingColumnData(String title, Class<?> clazz,
							RatingProcessor<?> processor){
		super(title, clazz);
		
		if(processor == null){
			throw new IllegalArgumentException("processor must not be null");
		}
		
		this.processor = processor;
	}
	
	/**
	 * @return the processor
	 */
	public RatingProcessor getProcessor(){
		return processor;
	}
}