package de.ba_leipzig.discoinv.tables;

import java.util.Vector;

import de.matthiasrothe.util.rating.RatingProcessor;

public class RatingTableModel extends GenericTableModel {
	private static final long serialVersionUID = -4139107471720190206L;
	private RatingColumnData ratingColumnData;
	private int ratingColumnID;
	
	public RatingTableModel(Vector data, Vector<ColumnData> columnData,
			RatingColumnData ratingColumnData) {
		
		super(data, columnData);
		
		if(ratingColumnData != null){
			this.ratingColumnID = super.findColumn(ratingColumnData.getTitle());
			this.ratingColumnData = ratingColumnData;
		}
	}
	
	public int getRatingColumn(){
		return ratingColumnID;
	}
	
	public RatingProcessor getRatingProcessor(){
		return ratingColumnData.getProcessor();
	}
	
	public boolean hasRatingColumn(){
		return ratingColumnData != null;
	}
}