package de.ba_leipzig.discoinv.tables;

import java.util.*;

import de.ba_leipzig.discoinv.tree.*;

public abstract class TableFactory {
	private static HashMap<String, Table> tables = new HashMap<String, Table>();
	
	public static Table getTable(TreeObjectType type, int id){
		String key = type + "-" + id;
		Table table = tables.get(key);
		
		if(table == null){
			table = createTable(type, id);
			tables.put(key, table);
		}
		
		return table;
	}

	private static Table createTable(TreeObjectType type, int id){
		Table table = null;
		
		switch(type){
			case place:
				table = new SinglePlaceTable(id);
				break;
			
			case beverage:
			case misc:
				table = new SingleInvObjectTable(id);
				break;
			
			default: new RuntimeException();
		}
		
		return table;
	}
}