package de.ba_leipzig.discoinv.tree;

import java.util.HashMap;

public enum TreeObjectType {
	root, place, beverage, misc;
	public static final HashMap<TreeObjectType, TreeElement<String>> baseTypes;
	
	static {
		baseTypes = new HashMap<TreeObjectType, TreeElement<String>>();
		
		TreeElement<String> rootElement =
			new TreeElement<String>("DiscoInv", root);		
		
		TreeElement<String> places =
			new TreeElement<String>("Standorte", place);
		
		TreeElement<String> beverages =
			new TreeElement<String>("Getrnke", beverage);
		
		TreeElement<String> miscs =
			new TreeElement<String>("Sonstiges", misc);
		
		baseTypes.put(root, rootElement);
		baseTypes.put(place, places);
		baseTypes.put(beverage, beverages);
		baseTypes.put(misc, miscs);
	}
}