package de.ba_leipzig.discoinv.tree;

import java.awt.*;
import java.sql.SQLException;

import javax.swing.event.*;
import javax.swing.tree.*;

import de.ba_leipzig.discoinv.ExceptionHandler;
import de.ba_leipzig.discoinv.tables.*;

public class TreeSelectionHandler implements TreeSelectionListener {
	private Component ui;
	private TableManager tableManager;
	
	public TreeSelectionHandler(Component ui, TableManager tableManager){
		if(ui == null){
			throw new NullPointerException("ui must not be null!");
		}
		if(tableManager == null){
			throw new NullPointerException("tableManager must not be null!");
		}
		
		this.ui = ui;
		this.tableManager = tableManager;
	}
	
	public void valueChanged(TreeSelectionEvent event){
		TreePath selectedPath = event.getNewLeadSelectionPath();
		if(selectedPath != null){
			Cursor cursor = ui.getCursor();
			ui.setCursor(new Cursor(Cursor.WAIT_CURSOR));
			
			try {
				tableManager.showTableForPath(selectedPath);
			}
			catch(SQLException e){
				String msg = "Beim Aufbau der Tabelle ist ein Datenbankfehler aufgetreten:";
				new ExceptionHandler(ui).handle(e, msg);
			}
			finally {
				ui.setCursor(cursor);
			}
		}
	}
}