package de.matthiasrothe.util.rating;

public abstract class AbstractRatingProcessor<T> implements RatingProcessor<T> {
	private Class<T> type;
	
	public AbstractRatingProcessor(Class<T> type){
		if(type == null){
			throw new IllegalArgumentException("type must not be null!");
		}
		
		this.type = type;
	}
	
	public Rating getRating(Object value) throws ProcessingException {
		if(value != null){
			try {
				return doGetRating(type.cast(value));
			}
			catch(Exception e){
				throw new ProcessingException(e);
			}
		}
		else {
			return Rating.normal;
		}
	}
	
	protected abstract Rating doGetRating(T value);
}