package de.matthiasrothe.util.rating;

public class DifferenceRatingProcessor extends AbstractRatingProcessor<Number> {
	private Number threshold;
	
	public DifferenceRatingProcessor(Number threshold){
		super(Number.class);
		
		this.threshold = threshold;
	}
	
	protected Rating doGetRating(Number value){
		Rating rating;
		
		if(value.doubleValue() < threshold.doubleValue()){
			rating = Rating.fatal;
		}
		else if(value.doubleValue() == threshold.doubleValue()){
			rating = Rating.critic;
		}
		else {
			rating = Rating.normal;
		}
		
		return rating;
	}
}