package de.matthiasrothe.util.rating;

public class RegexRatingProcessor extends AbstractRatingProcessor<String> {
	private String warningRegex;
	private String criticRegex;
	private String fatalRegex;
	
	public RegexRatingProcessor(String warningRegex, String criticRegex,
			String fatalRegex){
		super(String.class);
		
		if(	warningRegex == null	||
			criticRegex == null		||
			fatalRegex == null			)
		{
			throw new IllegalArgumentException("parameters must not be null!");
		}

		this.warningRegex = warningRegex;
		this.criticRegex = criticRegex;
		this.fatalRegex = fatalRegex;
	}

	protected Rating doGetRating(String value) {
		Rating rating = Rating.normal;
		
		if(value.matches(fatalRegex)){
			rating = Rating.fatal;
		}
		else if(value.matches(criticRegex)){
			rating = Rating.critic;
		}
		else if(value.matches(warningRegex)){
			rating = Rating.warning;
		}
		
		return rating;
	}
}