package de.matthiasrothe.util.rating;

public class StatusRatingProcessor extends AbstractRatingProcessor<String> {
	private String warningStatus;
	private String criticStatus;
	private String fatalStatus;
	
	public StatusRatingProcessor(String warningStatus, String criticStatus,
									String fatalStatus){
		super(String.class);
		
		if(	warningStatus == null	||
			criticStatus == null	||
			fatalStatus == null		)
		{
			throw new IllegalArgumentException("parameters must not be null!");
		}
		
		this.warningStatus = warningStatus;
		this.criticStatus = criticStatus;
		this.fatalStatus = fatalStatus;
	}
	
	protected Rating doGetRating(String value) {
		Rating rating = Rating.normal;
		
		if(value.equals(warningStatus)){
			rating = Rating.warning;
		}
		else if(value.equals(criticStatus)){
			rating = Rating.critic;
		}
		else if(value.equals(fatalStatus)){
			rating = Rating.fatal;
		}
		
		return rating;
	}
}